<div align="center">
 <a href="https://github.com/XiaoDaiGua-Ray/ray-template"> <img alt="Ray Template" width="200" height="200" src="https://r2chevereto.yka.moe/longmao.navigator.th.png"> </a> <br> <br>
 <a href="https://github.com/XiaoDaiGua-Ray/ray-template/blob/main/LICENSE"><img src="https://img.shields.io/github/license/XiaoDaiGua-Ray/ray-template" alt="LICENSE"></a>
</div>

<div align="center">

# Ray Template

English | [简体中文](https://github.com/XiaoDaiGua-Ray/ray-template/blob/main/README-ZH.md)

A `free`, `efficient`, `complete with features` middle and backend template based on the latest technologies such as vite5.x & ts(x) & pinia & vue3.x.

</div>

## ✨ Feature

- **Power by love**: Contains almost all common template features on the market and all are free to use.
- **Latest Technology Stack**：Developed using front-end cutting-edge technologies such as vue3.x/vite5.x/pinia.
- **TypeScript**：The language for application-level JavaScript.
- **App Theme**：Configurable themes.
- **Globalization**：Built-in complete internationalization solution.
- **Mock Data**：Built-in Mock data scheme.
- **Permissions**：Built-in complete dynamic routing permission generation solution.
- **Components**：Secondary encapsulation of multiple commonly used components.
- **Axios Request**：Secondary encapsulation of the axios library, supporting functions such as cancellation, anti-shake, automatic repeat cancellation, etc.
- **Page Cache**：Arbitrarily deep page cache.
- **SVG**：Built-in svg icon solution.
- **Standalone Data Methods Views**：Decoupled management of data, methods, and views allows for secondary development with confidence.
- **Template Specific Hooks** : Hooks based on the template feature package make it easier to use some of the features of the template.

## 🪄 Preview

- [Click to preview](https://xiaodaigua-ray.github.io/ray-template/#/)
- [Click to preview(Acceleration address)](https://ray-template.yunkuangao.com/#/)

## 🦾 Document

- [Document](https://xiaodaigua-ray.github.io/ray-template-doc/)
- [Document(Acceleration address)](https://ray-template.yunkuangao.com/ray-template-doc/)

## 🔋 Change Log

- [Change Log](https://github.com/XiaoDaiGua-Ray/xiaodaigua-ray.github.io/blob/main/CHANGELOG.md)

## 🪴 Prepare

- [Node](http://nodejs.org/) and [git](https://git-scm.com/) - Project development environment
- [Vite](https://vitejs.dev/) - Familiar with vite features
- [Vue3](https://v3.vuejs.org/) - Familiar with Vue3.x basic syntax
- [TypeScript](https://www.typescriptlang.org/) - Familiar with TypeScript basic syntax
- [Es6+](http://es6.ruanyifeng.com/) - Familiar with es6 basic syntax
- [Vue-Router-Next](https://next.router.vuejs.org/) - Familiar with the basic use of vue-router4.x
- [Naive-UI](https://www.naiveui.com) - UI basic usage
- [Mock.js](https://github.com/nuysoft/Mock) - Mockjs basic syntax
- [Pinia](https://pinia.vuejs.org/zh/introduction.html) - State manager pinia uses
- [TSX](https://github.com/vuejs/babel-plugin-jsx/blob/main/packages/babel-plugin-jsx/README-zh_CN.md) - TSX basic syntax

## 📦 Setup

### Get Project

```sh
# github
git clone https://github.com/XiaoDaiGua-Ray/ray-template.git

# If your download speed is very slow, you can switch to the proxy address below
git clone https://gh.yka.moe/https://github.com/XiaoDaiGua-Ray/ray-template.git
```

### Pull dependencies

```sh
pnpm i
```

### Startup project

```sh
pnpm dev
```

### Project packaging

```sh
pnpm build
```

### Preview project

```sh
pnpm preview
```

### Volumetric analysis

```sh
pnpm report
```

### Develop

Introduction and ease of use are the core ideas of this template. So you can safely delete all files under `views/demo` and `router/moduels/demo`, and you will have a clean project.

## 🪴 Project Activities

![Alt](https://repobeats.axiom.co/api/embed/fab6071297ab281913a42f07a2779b488cfd62b8.svg 'Repobeats analytics image')

### Contributor

Thanks for all their contributions 🐝!

<a href="https://github.com/XiaoDaiGua-Ray/ray-template/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=XiaoDaiGua-Ray/ray-template" />
</a>

## Browser Support

| [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/edge/edge_48x48.png" alt=" Edge" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>IE | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/edge/edge_48x48.png" alt=" Edge" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Edge | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/firefox/firefox_48x48.png" alt="Firefox" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Firefox | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/chrome/chrome_48x48.png" alt="Chrome" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Chrome | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/safari/safari_48x48.png" alt="Safari" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Safari |
| :--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | :----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | :-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | :-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: |
|                                                                                             not support                                                                                              |                                                                                            last 2 versions                                                                                             |                                                                                                  last 2 versions                                                                                                  |                                                                                                last 2 versions                                                                                                |                                                                                                last 2 versions                                                                                                |

## 📄 License

[MIT License](https://github.com/XiaoDaiGua-Ray/ray-template/blob/main/LICENSE) © 2022-PRESENT [Ray](https://github.com/XiaoDaiGua-Ray)
